import * as i0 from '@angular/core';
import { Injectable, Component, ViewChild, Input, NgModule } from '@angular/core';
import * as Prism from 'prismjs';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';

class AsPrismService {
    constructor() { }
}
AsPrismService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: AsPrismService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
AsPrismService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: AsPrismService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: AsPrismService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class AsPrismComponent {
    // get language(): string { return this._language; }
    // set language(language: string) {
    //   this._language = language || 'json';
    // }
    // private _language: string = "json"
    constructor() {
        this.language = 'json';
        console.log("Languages", Prism.languages);
    }
    ngAfterViewInit() {
        Prism.highlightElement(this.codeEle?.nativeElement);
    }
    ngOnChanges(changes) {
        if (changes?.code) {
            if (this.codeEle?.nativeElement) {
                this.codeEle.nativeElement.textContent = this.code;
                Prism.highlightElement(this.codeEle?.nativeElement);
            }
        }
    }
}
AsPrismComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: AsPrismComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
AsPrismComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.5", type: AsPrismComponent, selector: "as-prism", inputs: { code: "code", language: "language" }, viewQueries: [{ propertyName: "codeEle", first: true, predicate: ["codeEle"], descendants: true }], usesOnChanges: true, ngImport: i0, template: `
    <pre *ngIf="language" [class]="'language-' + language">
      <code #codeEle [class]="'language-' + language">{{code}}</code>
    </pre>
    {{language}}
  `, isInline: true, dependencies: [{ kind: "directive", type: i1.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: AsPrismComponent, decorators: [{
            type: Component,
            args: [{ selector: 'as-prism', template: `
    <pre *ngIf="language" [class]="'language-' + language">
      <code #codeEle [class]="'language-' + language">{{code}}</code>
    </pre>
    {{language}}
  ` }]
        }], ctorParameters: function () { return []; }, propDecorators: { codeEle: [{
                type: ViewChild,
                args: ['codeEle']
            }], code: [{
                type: Input
            }], language: [{
                type: Input
            }] } });

class AsPrismModule {
}
AsPrismModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: AsPrismModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
AsPrismModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.5", ngImport: i0, type: AsPrismModule, declarations: [AsPrismComponent], imports: [CommonModule], exports: [AsPrismComponent] });
AsPrismModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: AsPrismModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: AsPrismModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        AsPrismComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        AsPrismComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of as-prism
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AsPrismComponent, AsPrismModule, AsPrismService };
//# sourceMappingURL=as-prism.mjs.map
